unit UTestGrid;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, Grids,
  ExtCtrls, StdCtrls, Types;

type

  { TFTestGrid }

  TFarbe = class
    S, H: TColor;
  end;

  TFTestGrid = class(TForm)
    PbPasst: TButton;
    EdText: TEdit;
    EdY: TEdit;
    EdX: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Panel1: TPanel;
    Panel2: TPanel;
    RbSchwarz: TRadioButton;
    RbGruen: TRadioButton;
    RbRot: TRadioButton;
    RbBlau: TRadioButton;
    RbWeisz: TRadioButton;
    TestGrid: TStringGrid;
    procedure FormDestroy(Sender: TObject);
    procedure PbPasstClick(Sender: TObject);
    procedure TestGridActivate(Sender: TObject);
    procedure TestGridPrepareCanvas(Sender: TObject; aCol, aRow: Integer;
      aState: TGridDrawState);
  private
    procedure ClearGrid;

  public

  end;



var
  FTestGrid: TFTestGrid;


implementation

{$R *.lfm}

{ TFTestGrid }

procedure TFTestGrid.PbPasstClick(Sender: TObject);
Var
  ix, iy: Integer;
  Farbe: TFarbe;
begin
   Farbe := TFarbe.Create;

   If RbRot.Checked then Farbe.H:=clRed;
   If RbBlau.Checked then Farbe.H:=clBlue;
   If RbWeisz.Checked then Farbe.H:=clWhite;

   If RbSchwarz.Checked then Farbe.S:=clBlack;
   If RbGruen.Checked then Farbe.S:=clGreen;

   ix:=StrToInt(edX.Text);
   iy:=StrToInt(edY.Text);

   TestGrid.Cells[Iy, ix]:=edText.Text;
   TestGrid.Objects[IY, Ix] := Farbe;
end;

procedure TFTestGrid.FormDestroy(Sender: TObject);
begin
   ClearGrid;
end;

procedure TFTestGrid.ClearGrid;
var
  r, c: Integer;
begin
   for r := 0 to TestGrid.RowCount-1 do
     for c := 0 to TestGrid.ColCount-1 do
     begin
       TestGrid.Objects[c, r].Free;
       TestGrid.Objects[c, r] := nil;
     end;
end;

procedure TFTestGrid.TestGridActivate(Sender: TObject);
begin
   With TestGrid do
    begin
    RowCount:=11;
    ColCount:=8;
//    ACol:=4;
//    ARow:=6;
//    Rect.Top:=2;
//    Rect.Bottom:=4;
//    Rect.Left:=3;
//    Rect.Right:=6;
    end;
end;

procedure TFTestGrid.TestGridPrepareCanvas(Sender: TObject; aCol,
  aRow: Integer; aState: TGridDrawState);
var
  farbe: TFarbe;
begin
   farbe := TFarbe(TestGrid.Objects[aCol, aRow]);
   if farbe <> nil then
   begin
     TestGrid.Canvas.Brush.Color := farbe.H;
     TestGrid.Canvas.Font.Color := farbe.S;
   end;
end;

end.

